{- -*- coding: utf-8 -*- -}
#include <bindings.dsl.h>
#include <CoreServices/CoreServices.h>

module Bindings.CoreServices.CarbonCore.Files where
#strict_import
import Bindings.CoreServices.CarbonCore.Finder
import Bindings.CoreServices.CarbonCore.MacTypes

#starttype struct HFSUniStr255
#  field       length , <UInt16>
#  array_field unicode, <UniChar>
#stoptype
#synonym_t ConstHFSUniStr255Param, Ptr <HFSUniStr255>

#num kFSFileSecurityRemoveACL

#num fsCurPerm
#num fsRdPerm
#num fsWrPerm
#num fsRdWrPerm
#num fsRdWrShPerm

#num fsRdAccessPerm
#num fsWrAccessPerm
#num fsRdDenyPerm
#num fsWrDenyPerm

#num fsRtParID
#num fsRtDirID

#num fsAtMark
#num fsFromStart
#num fsFromLEOF
#num fsFromMark

#num kFSAllowConcurrentAsyncIOBit
#num kFSAllowConcurrentAsyncIOMask
#num kFSPleaseCacheBit
#num kFSPleaseCacheMask
#num kFSNoCacheBit
#num kFSNoCacheMask
#num kFSRdVerifyBit
#num kFSRdVerifyMask
#num kFSForceReadBit
#num kFSForceReadMask
#num kFSNewLineBit
#num kFSNewLineMask
#num kFSNewLineCharMask

#num fsSBPartialName
#num fsSBFullName
#num fsSBFlAttrib
#num fsSBFlFndrInfo
#num fsSBFlLgLen
#num fsSBFlPyLen
#num fsSBFlRLgLen
#num fsSBFlRPyLen
#num fsSBFlCrDat
#num fsSBFlMdDat
#num fsSBFlBkDat
#num fsSBFlXFndrInfo
#num fsSBFlParID
#num fsSBNegate
#num fsSBDrUsrWds
#num fsSBDrNmFls
#num fsSBDrCrDat
#num fsSBDrMdDat
#num fsSBDrBkDat
#num fsSBDrFndrInfo
#num fsSBDrParID
#num fsSBNodeID
#num fsSBAttributeModDate
#num fsSBAccessDate
#num fsSBPermissions
#num fsSBSkipPackageContents
#num fsSBSkipHiddenItems
#num fsSBUserID
#num fsSBGroupID

#num fsSBPartialNameBit
#num fsSBFullNameBit
#num fsSBFlAttribBit
#num fsSBFlFndrInfoBit
#num fsSBFlLgLenBit
#num fsSBFlPyLenBit
#num fsSBFlRLgLenBit
#num fsSBFlRPyLenBit
#num fsSBFlCrDatBit
#num fsSBFlMdDatBit
#num fsSBFlBkDatBit
#num fsSBFlXFndrInfoBit
#num fsSBFlParIDBit
#num fsSBNegateBit
#num fsSBDrUsrWdsBit
#num fsSBDrNmFlsBit
#num fsSBDrCrDatBit
#num fsSBDrMdDatBit
#num fsSBDrBkDatBit
#num fsSBDrFndrInfoBit
#num fsSBDrParIDBit
#num fsSBNodeIDBit
#num fsSBAttributeModDateBit
#num fsSBAccessDateBit
#num fsSBPermissionsBit
#num fsSBSkipPackageContentsBit
#num fsSBSkipHiddenItemsBit
#num fsSBUserIDBit
#num fsSBGroupIDBit

#num bLimitFCBs
#num bLocalWList
#num bNoMiniFndr
#num bNoVNEdit
#num bNoLclSync
#num bTrshOffLine
#num bNoSwitchTo
#num bNoDeskItems
#num bNoBootBlks
#num bAccessCntl
#num bNoSysDir
#num bHasExtFSVol
#num bHasOpenDeny
#num bHasCopyFile
#num bHasMoveRename
#num bHasDesktopMgr
#num bHasShortName
#num bHasFolderLock
#num bHasPersonalAccessPrivileges
#num bHasUserGroupList
#num bHasCatSearch
#num bHasFileIDs
#num bHasBTreeMgr
#num bHasBlankAccessPrivileges
#num bSupportsAsyncRequests
#num bSupportsTrashVolumeCache

#num bHasDirectIO

#num bIsEjectable
#num bSupportsHFSPlusAPIs
#num bSupportsFSCatalogSearch
#num bSupportsFSExchangeObjects
#num bSupports2TBFiles
#num bSupportsLongNames
#num bSupportsMultiScriptNames
#num bSupportsNamedForks
#num bSupportsSubtreeIterators
#num bL2PCanMapFileBlocks
#num bParentModDateChanges
#num bAncestorModDateChanges
#num bSupportsSymbolicLinks
#num bIsAutoMounted
#num bAllowCDiDataHandler
#num bSupportsExclusiveLocks
#num bSupportsJournaling
#num bNoVolumeSizes
#num bIsOnInternalBus
#num bIsCaseSensitive
#num bIsCasePreserving
#num bDoNotDisplay
#num bIsRemovable
#num bNoRootTimes
#num bIsOnExternalBus
#num bSupportsExtendedFileSecurity

#num kWidePosOffsetBit
#num kUseWidePositioning
#num kMaximumBlocksIn4GB

#num fsUnixPriv

#num kNoUserAuthentication
#num kPassword
#num kEncryptPassword
#num kTwoWayEncryptPassword

#num knoUser
#num kadministratorUser

#num knoGroup

#synonym_t  FSVolumeRefNum, <SInt16>
#integral_t FSIORefNum

#num kFSInvalidVolumeRefNum

#starttype struct FSRef
#  array_field hidden, <UInt8>
#stoptype
#synonym_t FSRefPtr, Ptr <FSRef>

#opaque_t  __FSFileSecurity
#synonym_t FSFileSecurityRef, Ptr <__FSFileSecurity>

#starttype struct CatPositionRec
#  field       initialize, <SInt16>
#  array_field priv      , <SInt16>
#stoptype

#if __LP64__
#  starttype struct FSSpec
#    array_field hidden, <UInt8>
#  stoptype
#else
#  starttype struct FSSpec
#    field vRefNum, <FSVolumeRefNum>
#    field parID  , <SInt32>
#    field name   , <StrFileName>
#  stoptype
#endif
#synonym_t FSSpecPtr     , Ptr <FSSpec>
#synonym_t FSSpecHandle  , Ptr <FSSpecPtr>
#synonym_t FSSpecArrayPtr, <FSSpecPtr>
#synonym_t ConstFSSpecPtr, Ptr <FSSpec>

#if __LP64__
#  synonym_t ParmBlkPtr, Ptr ()
#else
#  synonym_t ParmBlkPtr, Ptr <ParamBlockRec>
#endif

#callback  IOCompletionProcPtr, <ParmBlkPtr> -> IO ()
#synonym_t IOCompletionUPP    , <IOCompletionProcPtr>

#if !__LP64__
#  starttype struct IOParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioRefNum    , <FSIORefNum>
#    field ioVersNum   , <SInt8>
#    field ioPermssn   , <SInt8>
#    field ioMisc      , <Ptr>
#    field ioBuffer    , <Ptr>
#    field ioReqCount  , <SInt32>
#    field ioActCount  , <SInt32>
#    field ioPosMode   , <SInt16>
#    field ioPosOffset , <SInt32>
#  stoptype
#  synonym_t IOParamPtr, Ptr <IOParam>

#  starttype struct FileParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioFRefNum   , <FSIORefNum>
#    field ioFVersNum  , <SInt8>
#    field filler1     , <SInt8>
#    field ioFDirIndex , <SInt16>
#    field ioFlAttrib  , <SInt8>
#    field ioFlVersNum , <SInt8>
#    field ioFlFndrInfo, <FInfo>
#    field ioFlNum     , <UInt32>
#    field ioFlStBlk   , <UInt16>
#    field ioFlLgLen   , <SInt32>
#    field ioFlPyLen   , <SInt32>
#    field ioFlRStBlk  , <UInt16>
#    field ioFlRLgLen  , <SInt32>
#    field ioFlRPyLen  , <SInt32>
#    field ioFlCrDat   , <UInt32>
#    field ioFlMdDat   , <UInt32>
#  stoptype
#  synonym_t FileParamPtr, Ptr <FileParam>

#  starttype struct VolumeParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field filler2     , <UInt32>
#    field ioVolIndex  , <SInt16>
#    field ioVCrDate   , <UInt32>
#    field ioVLsBkUp   , <UInt32>
#    field ioVAtrb     , <UInt16>
#    field ioVNmFls    , <UInt16>
#    field ioVDirSt    , <UInt16>
#    field ioVBlLn     , <SInt16>
#    field ioVNmAlBlks , <UInt16>
#    field ioVAlBlkSiz , <UInt32>
#    field ioVClpSiz   , <UInt32>
#    field ioAlBlSt    , <UInt16>
#    field ioVNxtFNum  , <UInt32>
#    field ioVFrBlk    , <UInt16>
#  stoptype
#  synonym_t VolumeParamPtr, Ptr <VolumeParam>

#  starttype struct CntrlParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioCRefNum   , <FSIORefNum>
#    field csCode      , <SInt16>
#    array_field csParam, <SInt16>
#  stoptype
#  synonym_t CntrlParamPtr, Ptr <CntrlParamPtr>

#  starttype struct SlotDevParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioSRefNum   , <FSIORefNum>
#    field ioSVersNum  , <SInt8>
#    field ioSPermssn  , <SInt8>
#    field ioSMix      , <Ptr>
#    field ioSFlags    , <SInt16>
#    field ioSlot      , <SInt8>
#    field ioID        , <SInt8>
#  stoptype
#  synonym_t SlotDevParamPtr, Ptr <SlotDevParam>

#  starttype struct MultiDevParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioMRefNum   , <FSIORefNum>
#    field ioMVersNum  , <SInt8>
#    field ioMPermssn  , <SInt8>
#    field ioMMix      , <Ptr>
#    field ioMFlags    , <SInt16>
#    field ioSEBlkPtr  , <Ptr>
#  stoptype
#  synonym_t MultiDevParamPtr, Ptr <MultiDevParam>

#  starttype union ParamBlockRec
#    union_field ioParam      , <IOParam>
#    union_field fileParam    , <FileParam>
#    union_field volumeParam  , <VolumeParam>
#    union_field cntrlParam   , <CntrlParam>
#    union_field slotDevParam , <SlotDevParam>
#    union_field multiDevParam, <MultiDevParam>
#  stoptype

#  starttype struct HFileInfo
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioFRefNum   , <FSIORefNum>
#    field ioFVersNum  , <SInt8>
#    field filler1     , <SInt8>
#    field ioFDirIndex , <SInt16>
#    field ioFlAttrib  , <SInt8>
#    field ioACUser    , <SInt8>
#    field ioFlFndrInfo, <FInfo>
#    field ioDirID     , <SInt32>
#    field ioFlStBlk   , <UInt16>
#    field ioFlLgLen   , <SInt32>
#    field ioFlPyLen   , <SInt32>
#    field ioFlRStBlk  , <UInt16>
#    field ioFlRLgLen  , <SInt32>
#    field ioFlRPyLen  , <SInt32>
#    field ioFlCrDat   , <UInt32>
#    field ioFlMdDat   , <UInt32>
#    field ioFlBkDat   , <UInt32>
#    field ioFlXFndrInfo, <FXInfo>
#    field ioFlParID   , <SInt32>
#    field ioFlClpSiz  , <SInt32>
#  stoptype

#  starttype struct DirInfo
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioFRefNum   , <FSIORefNum>
#    field ioFVersNum  , <SInt8>
#    field filler1     , <SInt8>
#    field ioFDirIndex , <SInt16>
#    field ioFlAttrib  , <SInt8>
#    field ioACUser    , <SInt8>
#    field ioDrUsrWds  , <DInfo>
#    field ioDrDirID   , <SInt32>
#    field ioDrNmFls   , <UInt16>
#    array_field filler3, <SInt16>
#    field ioDrCrDat   , <UInt32>
#    field ioDrMdDat   , <UInt32>
#    field ioDrBkDat   , <UInt32>
#    field ioDrFndrInfo, <DXInfo>
#    field ioDrParID   , <SInt32>
#  stoptype

#  starttype union CInfoPBRec
#    union_field hFileInfo, <HFileInfo>
#    union_field dirInfo  , <DirInfo>
#  stoptype
#  synonym_t CInfoPBPtr, Ptr <CInfoPBRec>

#  starttype struct XCInfoPBRec
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <ProcPtr>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field filler1     , <SInt32>
#    field ioShortNamePtr, <StringPtr>
#    field filler2     , <SInt16>
#    field ioPDType    , <SInt16>
#    field ioPDAuxType , <SInt32>
#    array_field filler3, <SInt32>
#    field ioDirID     , <SInt32>
#  stoptype
#  synonym_t XCInfoPBPtr, Ptr <XCInfoPBRec>

#  starttype struct DTPBRec
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioDTRefNum  , <FSIORefNum>
#    field ioIndex     , <SInt16>
#    field ioTagInfo   , <SInt16>
#    field ioDTBuffer  , <Ptr>
#    field ioDTReqCount, <SInt32>
#    field ioDTActCount, <SInt32>
#    field ioFiller1   , <SInt8>
#    field ioIconType  , <UInt8>
#    field ioFiller2   , <SInt16>
#    field ioDirID     , <SInt32>
#    field ioFileCreator, <OSType>
#    field ioFileType  , <OSType>
#    field ioFiller3   , <SInt32>
#    field ioDTLgLen   , <SInt32>
#    field ioDTPyLen   , <SInt32>
#    array_field ioFiller4, <SInt16>
#    field ioAPPLParID , <SInt32>
#  stoptype
#  synonym_t DTPBPtr, Ptr <DTPBRec>

#  starttype struct HIOParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioRefNum    , <FSIORefNum>
#    field ioVersNum   , <SInt8>
#    field ioPermssn   , <SInt8>
#    field ioMisc      , <Ptr>
#    field ioBuffer    , <Ptr>
#    field ioReqCount  , <SInt32>
#    field ioActCount  , <SInt32>
#    field ioPosMode   , <SInt16>
#    field ioPosOffset , <SInt32>
#  stoptype
#  synonym_t HIOParamPtr, Ptr <HIOParam>

#  starttype struct HFileParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioFRefNum   , <FSIORefNum>
#    field ioFVersNum  , <SInt8>
#    field filler1     , <SInt8>
#    field ioFDirIndex , <SInt16>
#    field ioFlAttrib  , <SInt8>
#    field ioFlVersNum , <SInt8>
#    field ioFlFndrInfo, <FInfo>
#    field ioDirID     , <SInt32>
#    field ioFlStBlk   , <UInt16>
#    field ioFlLgLen   , <SInt32>
#    field ioFlPyLen   , <SInt32>
#    field ioFlRStBlk  , <UInt16>
#    field ioFlRLgLen  , <SInt32>
#    field ioFlRPyLen  , <SInt32>
#    field ioFlCrDat   , <UInt32>
#    field ioFlMdDat   , <UInt32>
#  stoptype
#  synonym_t HFileParamPtr, Ptr <HFileParam>

#  starttype struct HVolumeParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field filler2     , <UInt32>
#    field ioVolIndex  , <SInt16>
#    field ioVCrDate   , <UInt32>
#    field ioVLsMod    , <UInt32>
#    field ioVAtrb     , <SInt16>
#    field ioVNmFls    , <UInt16>
#    field ioVBitMap   , <UInt16>
#    field ioAllocPtr  , <UInt16>
#    field ioVNmAlBlks , <UInt16>
#    field ioVAlBlkSiz , <UInt32>
#    field ioVClpSiz   , <UInt32>
#    field ioAlBlSt    , <UInt16>
#    field ioVNxtCNID  , <UInt16>
#    field ioVFrBlk    , <UInt16>
#    field ioVSigWord  , <UInt16>
#    field ioVDrvInfo  , <SInt16>
#    field ioVDRefNum  , <FSIORefNum>
#    field ioVFSID     , <SInt16>
#    field ioVBkUp     , <UInt32>
#    field ioVSeqNum   , <SInt16>
#    field ioVWrCnt    , <UInt32>
#    field ioVFilCnt   , <UInt32>
#    field ioVDirCnt   , <UInt32>
#    array_field ioVFndrInfo, <SInt32>
#  stoptype
#  synonym_t HVolumeParamPtr, Ptr <HVolumeParam>

#  starttype struct XIOParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioRefNum    , <FSIORefNum>
#    field ioVersNum   , <SInt8>
#    field ioPermssn   , <SInt8>
#    field ioMisc      , <Ptr>
#    field ioBuffer    , <Ptr>
#    field ioReqCount  , <SInt32>
#    field ioActCount  , <SInt32>
#    field ioPosMode   , <SInt16>
#    field ioWPosOffset, <wide>
#  stoptype
#  synonym_t XIOParamPtr, Ptr <XIOParam>

#  starttype struct XVolumeParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioXVersion  , <UInt32>
#    field ioVolIndex  , <SInt16>
#    field ioVCrDate   , <UInt32>
#    field ioVLsMod    , <UInt32>
#    field ioVAtrb     , <SInt16>
#    field ioVNmFls    , <UInt16>
#    field ioVBitMap   , <UInt16>
#    field ioAllocPtr  , <UInt16>
#    field ioVNmAlBlks , <UInt16>
#    field ioVAlBlkSiz , <UInt32>
#    field ioVClpSiz   , <UInt32>
#    field ioAlBlSt    , <UInt16>
#    field ioVNxtCNID  , <UInt16>
#    field ioVFrBlk    , <UInt16>
#    field ioVSigWord  , <UInt16>
#    field ioVDrvInfo  , <SInt16>
#    field ioVDRefNum  , <FSIORefNum>
#    field ioVFSID     , <SInt16>
#    field ioVBkUp     , <UInt32>
#    field ioVSeqNum   , <SInt16>
#    field ioVWrCnt    , <UInt32>
#    field ioVFilCnt   , <UInt32>
#    field ioVDirCnt   , <UInt32>
#    array_field ioVFndrInfo, <SInt32>
#    field ioVTotalBytes, <UInt64>
#    field ioVFreeBytes , <UInt64>
#  stoptype
#  synonym_t XVolumeParamPtr, Ptr <XVolumeParam>

#  starttype struct AccessParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioRefNum    , <FSIORefNum>
#    field ioDenyModes , <SInt16>
#    field filler4     , <SInt16>
#    field filler5     , <SInt8>
#    field ioACUser    , <SInt8>
#    field filler6     , <SInt32>
#    field ioACOwnerID , <SInt32>
#    field ioACGroupID , <SInt32>
#    field ioACAccess  , <SInt32>
#    field ioDirID     , <SInt32>
#  stoptype
#  synonym_t AccessParamPtr, Ptr <AccessParam>

#  starttype struct ObjParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field filler7     , <SInt16>
#    field ioObjType   , <SInt16>
#    field ioObjNamePtr, <StringPtr>
#    field ioObjID     , <SInt32>
#  stoptype
#  synonym_t ObjParamPtr, Ptr <ObjParam>

#  starttype struct CopyParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioDstVRefNum, <FSVolumeRefNum>
#    field filler8     , <SInt16>
#    field ioNewName   , <StringPtr>
#    field ioCopyName  , <StringPtr>
#    field ioNewDirID  , <SInt32>
#    field filler14    , <SInt32>
#    field filler15    , <SInt32>
#    field ioDirID     , <SInt32>
#  stoptype
#  synonym_t CopyParamPtr, Ptr <CopyParam>

#  starttype struct WDParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioWDCreated , <SInt16>
#    field ioWDIndex   , <SInt16>
#    field ioWDProcID  , <SInt32>
#    field ioWDVRefNum , <FSVolumeRefNum>
#    field filler10    , <SInt16>
#    field filler11    , <SInt32>
#    field filler12    , <SInt32>
#    field filler13    , <SInt32>
#    field ioWDDirID   , <SInt32>
#  stoptype
#  synonym_t WDParamPtr, Ptr <WDParam>

#  starttype struct FIDParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field filler14    , <SInt32>
#    field ioDestNamePtr, <StringPtr>
#    field filler15    , <SInt32>
#    field ioDestDirID , <SInt32>
#    field filler16    , <SInt32>
#    field filler17    , <SInt32>
#    field ioSrcDirID  , <SInt32>
#    field filler18    , <SInt16>
#    field ioFileID    , <SInt32>
#  stoptype
#  synonym_t FIDParamPtr, Ptr <FIDParam>

#  starttype struct ForeignPrivParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioFiller21  , <SInt32>
#    field ioFiller22  , <SInt32>
#    field ioForeignPrivBuffer  , <Ptr>
#    field ioForeignPrivActCount, <SInt32>
#    field ioForeignPrivReqCount, <SInt32>
#    field ioFiller23           , <SInt32>
#    field ioForeignPrivDirID   , <SInt32>
#    field ioForeignPrivInfo1   , <SInt32>
#    field ioForeignPrivInfo2   , <SInt32>
#    field ioForeignPrivInfo3   , <SInt32>
#    field ioForeignPrivInfo4   , <SInt32>
#  stoptype
#  synonym_t ForeignPrivParamPtr, Ptr <ForeignPrivParam>

#  starttype struct CSParam
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioMatchPtr  , <FSSpecPtr>
#    field ioReqMatchCount, <SInt32>
#    field ioActMatchCount, <SInt32>
#    field ioSearchBits   , <SInt32>
#    field ioSearchInfo1  , <CInfoPBPtr>
#    field ioSearchInfo2  , <CInfoPBPtr>
#    field ioSearchTime   , <SInt32>
#    field ioCatPosition  , <CatPositionRec>
#    field ioOptBuffer    , <Ptr>
#    field ioOptBufSize   , <SInt32>
#  stoptype
#  synonym_t CSParamPtr, Ptr <CSParam>

#  starttype union HParamBlockRec
#    union_field ioParam    , <HIOParam>
#    union_field fileParam  , <HFileParam>
#    union_field volumeParam, <HVolumeParam>
#    union_field accessParam, <AccessParam>
#    union_field objParam   , <ObjParam>
#    union_field copyParam  , <CopyParam>
#    union_field wdParam    , <WDParam>
#    union_field fidParam   , <FIDParam>
#    union_field csParam    , <CSParam>
#    union_field foreignPrivParam, <ForeignPrivParam>
#  stoptype
#  synonym_t HParmBlkPtr, Ptr <HParamBlockRec>

#  starttype struct CMovePBRec
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field filler1     , <SInt32>
#    field ioNewName   , <StringPtr>
#    field filler2     , <SInt32>
#    field ioNewDirID  , <SInt32>
#    array_field filler3, <SInt32>
#    field ioDirID     , <SInt32>
#  stoptype
#  synonym_t CMovePBPtr, Ptr <CMovePBRec>

#  starttype struct WDPBRec
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field filler1     , <SInt16>
#    field ioWDIndex   , <SInt16>
#    field ioWDProcID  , <SInt32>
#    field ioWDVRefNum , <FSVolumeRefNum>
#    array_field filler2, <SInt16>
#    field ioWDDirID   , <SInt32>
#  stoptype
#  synonym_t WDPBPtr, Ptr <WDPBRec>

#  starttype struct FCBPBRec
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field ioTrap      , <SInt16>
#    field ioCmdAddr   , <Ptr>
#    field ioCompletion, <IOCompletionUPP>
#    field ioResult    , <OSErr>
#    field ioNamePtr   , <StringPtr>
#    field ioVRefNum   , <FSVolumeRefNum>
#    field ioRefNum    , <FSIORefNum>
#    field filler      , <SInt16>
#    field ioFCBIndx   , <SInt16>
#    field filler1     , <SInt16>
#    field ioFCBFlNm   , <SInt32>
#    field ioFCBFlags  , <SInt16>
#    field ioFCBStBlk  , <UInt16>
#    field ioFCBEOF    , <SInt32>
#    field ioFCBPLen   , <SInt32>
#    field ioFCBCrPs   , <SInt32>
#    field ioFCBVRefNum, <FSVolumeRefNum>
#    field ioFCBClpSiz , <SInt32>
#    field ioFCBParID  , <SInt32>
#  stoptype
#  synonym_t FCBPBPtr, Ptr <FCBPBRec>

#  starttype struct VCB
#    field qLink       , <QElemPtr>
#    field qType       , <SInt16>
#    field vcbFlags    , <SInt16>
#    field vcbSigWord  , <UInt16>
#    field vcbCrDate   , <UInt32>
#    field vcbLsMod    , <SInt16>
#    field vcbAtrb     , <SInt16>
#    field vcbVBMSt    , <SInt16>
#    field vcbAllocPtr , <SInt16>
#    field vcbNmAlBlks , <UInt16>
#    field vcbAlBlkSiz , <SInt32>
#    field vcbClpSiz   , <SInt32>
#    field vcbAlBlSt   , <SInt16>
#    field vcbNxtCNID  , <SInt32>
#    field vcbFreeBks  , <UInt16>
#    field vcbVN       , <Str27>
#    field vcbDrvNum   , <SInt16>
#    field vcbDRefNum  , <FSIORefNum>
#    field vcbFSID     , <SInt16>
#    field vcbVRefNum  , <FSVolumeRefNum>
#    field vcbMAdr     , <Ptr>
#    field vcbBufAdr   , <Ptr>
#    field vcbMLen     , <SInt16>
#    field vcbDirIndex , <SInt16>
#    field vcbDirBlk   , <SInt16>
#    field vcbVolBkUp  , <UInt32>
#    field vcbVSeqNum  , <UInt16>
#    field vcbWrCnt    , <SInt16>
#    field vcbXTClpSiz , <SInt32>
#    field vcbCTClpSiz , <SInt32>
#    field vcbNmRtDirs , <UInt16>
#    field vcbFilCnt   , <SInt32>
#    field vcbDirCnt   , <SInt32>
#    array_field vcbFndrInfo, <SInt32>
#    field vcbVCSize   , <UInt16>
#    field vcbVBMCSiz  , <UInt16>
#    field vcbCtlCSiz  , <UInt16>
#    field vcbXTAlBlks , <UInt16>
#    field vcbCTAlBlks , <UInt16>
#    field vcbXTRef    , <SInt16>
#    field vcbCTRef    , <SInt16>
#    field vcbCtlBuf   , <Ptr>
#    field vcbDirIDM   , <SInt32>
#    field vcbOffsM    , <SInt16>
#  stoptype
#  synonym_t VCBtr, Ptr <VCB>

#  starttype DrvQEl
#    field qLink   , <QElemPtr>
#    field qType   , <SInt16>
#    field dQDrive , <SInt16>
#    field dQRefNum, <SInt16>
#    field dQFSID  , <SInt16>
#    field dQDrvSz , <UInt16>
#    field dQDrvSz2, <UInt16>
#  stoptype
#  synonym_t DrvQElPtr, Ptr <DrvQEl>
#endif

#starttype struct FSPermissionInfo
#  field userID    , <UInt32>
#  field groupID   , <UInt32>
#  field reserved1 , <UInt8>
#  field userAccess, <UInt8>
#  field mode      , <UInt16>
#  field fileSec   , <FSFileSecurityRef>
#stoptype

#synonym_t FSCatalogInfoBitmap, <UInt32>
#num kFSCatInfoNone
#num kFSCatInfoTextEncoding
#num kFSCatInfoNodeFlags
#num kFSCatInfoVolume
#num kFSCatInfoParentDirID
#num kFSCatInfoNodeID
#num kFSCatInfoCreateDate
#num kFSCatInfoContentMod
#num kFSCatInfoAttrMod
#num kFSCatInfoAccessDate
#num kFSCatInfoBackupDate
#num kFSCatInfoPermissions
#num kFSCatInfoFinderInfo
#num kFSCatInfoFinderXInfo
#num kFSCatInfoValence
#num kFSCatInfoDataSizes
#num kFSCatInfoRsrcSizes
#num kFSCatInfoSharingFlags
#num kFSCatInfoUserPrivs
#num kFSCatInfoUserAccess
#num kFSCatInfoSetOwnership
#num kFSCatInfoFSFileSecurityRef
#num kFSCatInfoAllDates
#num kFSCatInfoGettableInfo
#num kFSCatInfoSettableInfo
#num kFSCatInfoReserved

#num kFSNodeLockedBit
#num kFSNodeLockedMask
#num kFSNodeResOpenBit
#num kFSNodeResOpenMask
#num kFSNodeDataOpenBit
#num kFSNodeDataOpenMask
#num kFSNodeIsDirectoryBit
#num kFSNodeIsDirectoryMask
#num kFSNodeCopyProtectBit
#num kFSNodeCopyProtectMask
#num kFSNodeForkOpenBit
#num kFSNodeForkOpenMask
#num kFSNodeHardLinkBit
#num kFSNodeHardLinkMask

#num kFSNodeInSharedBit
#num kFSNodeInSharedMask
#num kFSNodeIsMountedBit
#num kFSNodeIsMountedMask
#num kFSNodeIsSharePointBit
#num kFSNodeIsSharePointMask

#ifdef __LP64__
#  starttype struct FSCatalogInfo
#    field nodeFlags       , <UInt16>
#    field volume          , <FSVolumeRefNum>
#    field parentDirID     , <UInt32>
#    field nodeID          , <UInt32>
#    field sharingFlags    , <UInt8>
#    field userPrivileges  , <UInt8>
#    field reserved1       , <UInt8>
#    field reserved2       , <UInt8>
#    field createDate      , <UTCDateTime>
#    field contentModDate  , <UTCDateTime>
#    field attributeModDate, <UTCDateTime>
#    field accessDate      , <UTCDateTime>
#    field backupDate      , <UTCDateTime>
#    field permissions     , <FSPermissionInfo>
#    array_field finderInfo, <UInt8>
#    array_field extFinderInfo, <UInt8>
#    field dataLogicalSize , <UInt64>
#    field dataPhysicalSize, <UInt64>
#    field rsrcLogicalSize , <UInt64>
#    field rsrcPhysicalSize, <UInt64>
#    field valence         , <UInt32>
#    field textEncodingHint, <TextEncoding>
#  stoptype
#else
#  starttype struct FSCatalogInfo
#    field nodeFlags       , <UInt16>
#    field volume          , <FSVolumeRefNum>
#    field parentDirID     , <UInt32>
#    field nodeID          , <UInt32>
#    field sharingFlags    , <UInt8>
#    field userPrivileges  , <UInt8>
#    field reserved1       , <UInt8>
#    field reserved2       , <UInt8>
#    field createDate      , <UTCDateTime>
#    field contentModDate  , <UTCDateTime>
#    field attributeModDate, <UTCDateTime>
#    field accessDate      , <UTCDateTime>
#    field backupDate      , <UTCDateTime>
#    array_field permissions, <UInt32>
#    array_field finderInfo, <UInt8>
#    array_field extFinderInfo, <UInt8>
#    field dataLogicalSize , <UInt64>
#    field dataPhysicalSize, <UInt64>
#    field rsrcLogicalSize , <UInt64>
#    field rsrcPhysicalSize, <UInt64>
#    field valence         , <UInt32>
#    field textEncodingHint, <TextEncoding>
#  stoptype
#endif

#starttype struct FSRefParam
#  field qLink       , <QElemPtr>
#  field qType       , <SInt16>
#  field ioTrap      , <SInt16>
#  field ioCmdAddr   , <Ptr>
#  field ioCompletion, <IOCompletionUPP>
#  field ioResult    , <OSErr>
#  field ioNamePtr   , <StringPtr>
#  field ioVRefNum   , <FSVolumeRefNum>
#  field reserved1   , <SInt16>
#  field reserved2   , <UInt8>
#  field reserved3   , <UInt8>
#  field ref         , Ptr <FSRef>
#  field whichInfo   , <FSCatalogInfoBitmap>
#  field catInfo     , Ptr <FSCatalogInfo>
#  field nameLength  , <UniCharCount>
#  field name        , Ptr <UniChar>
#  field ioDirID     , <UInt32>
#  field spec        , <FSSpecPtr>
#  field parentRef   , Ptr <FSRef>
#  field newRef      , Ptr <FSRef>
#  field textEncodingHint, <TextEncoding>
#  field outName     , Ptr <HFSUniStr255>
#stoptype
#synonym_t FSRefParamPtr, Ptr <FSRefParam>

#starttype struct FSRefForkIOParam
#  field qLink       , <QElemPtr>
#  field qType       , <SInt16>
#  field ioTrap      , <SInt16>
#  field ioCmdAddr   , <Ptr>
#  field ioCompletion, <IOCompletionUPP>
#  field ioResult    , <OSErr>
#  field parentRef   , Ptr <FSRef>
#  field nameLength  , <UniCharCount>
#  field name        , Ptr <UniChar>
#  field whichInfo   , <FSCatalogInfoBitmap>
#  field catInfo     , Ptr <FSCatalogInfo>
#  field forkNameLength, <UniCharCount>
#  field forkName    , Ptr <UniChar>
#  field permissions , <SInt8>
#  field reserved1   , <UInt8>
#  field forkRefNum  , <FSIORefNum>
#  field newRef      , Ptr <FSRef>
#stoptype
#synonym_t FSRefForkIOParamPtr, Ptr <FSRefForkIOParam>

#opaque_t OpaqueFSIterator
#synonym_t FSIterator, Ptr <OpaqueFSIterator>

#num kFSIterateFlat
#num kFSIterateSubtree
#num kFSIterateDelete
#num kFSIterateReserved

#synonym_t FSIteratorFlags, <OptionBits>

#starttype struct FSSearchParams
#  field searchTime      , <Duration>
#  field searchBits      , <OptionBits>
#  field searchNameLength, <UniCharCount>
#  field searchName      , Ptr <UniChar>
#  field searchInfo1     , Ptr <FSCatalogInfo>
#  field searchInfo2     , Ptr <FSCatalogInfo>
#stoptype
#synonym_t FSSearchParamsPtr, Ptr <FSSearchParams>

#starttype struct FSCatalogBulkParam
#  field qLink       , <QElemPtr>
#  field qType       , <SInt16>
#  field ioTrap      , <SInt16>
#  field ioCmdAddr   , <Ptr>
#  field ioCompletion, <IOCompletionUPP>
#  field ioResult    , <OSErr>
#  field containerChanged, <Boolean>
#  field reserved    , <UInt8>
#  field iteratorFlags, <FSIteratorFlags>
#  field iterator    , <FSIterator>
#  field container   , Ptr <FSRef>
#  field maximumItems, <ItemCount>
#  field actualItems , <ItemCount>
#  field whichInfo   , <FSCatalogInfoBitmap>
#  field catalogInfo , Ptr <FSCatalogInfo>
#  field refs        , Ptr <FSRef>
#  field specs       , <FSSpecPtr>
#  field names       , Ptr <HFSUniStr255>
#  field searchParams, Ptr <FSSearchParams>
#stoptype
#synonym_t FSCatalogBulkParamPtr, Ptr <FSCatalogBulkParam>

#synonym_t FSAllocationFlags, <UInt16>
#num kFSAllocDefaultFlags
#num kFSAllocAllOrNothingMask
#num kFSAllocContiguousMask
#num kFSAllocNoRoundUpMask
#num kFSAllocReservedMask

#starttype struct FSForkIOParam
#  field qLink       , <QElemPtr>
#  field qType       , <SInt16>
#  field ioTrap      , <SInt16>
#  field ioCmdAddr   , <Ptr>
#  field ioCompletion, <IOCompletionUPP>
#  field ioResult    , <OSErr>
#  field reserved1   , Ptr ()
#  field reserved2   , <SInt16>
#  field forkRefNum  , <FSIORefNum>
#  field reserved3   , <UInt8>
#  field permissions , <SInt8>
#  field ref         , Ptr <FSRef>
#  field buffer      , <Ptr>
#  field requestCount, <UInt32>
#  field actualCount , <UInt32>
#  field positionMode, <UInt16>
#  field positionOffset, <SInt64>
#  field allocationFlags, <FSAllocationFlags>
#  field allocationAmount, <UInt64>
#  field forkNameLength, <UniCharCount>
#  field forkName, Ptr <UniChar>
#  field forkIterator, <CatPositionRec>
#  field outForkName , Ptr <HFSUniStr255>
#stoptype
#synonym_t FSForkIOParamPtr, Ptr <FSForkIOParam>

{-
　　　　　　　　*'``・* 。
　　　　　　　　|　　　　 `*。
　　　　 　　,｡∩　　　　 　* 　　　もうどうにでもな〜れ
　　　　　　+　(´･ω･`)　*｡+ﾟ
　　　　　　`*｡ ヽ、　 つ *ﾟ*
　　　　　　　`・+｡*・' ﾟ⊃ +ﾟ
　　　　　　　☆　　 ∪~ ｡*ﾟ
　 　　　　　　`・+｡*・ ﾟ 
-}

#starttype struct FSForkInfo
#  field flags      , <SInt8>
#  field permissions, <SInt8>
#  field volume     , <FSVolumeRefNum>
#  field reserved2  , <UInt32>
#  field nodeID     , <UInt32>
#  field forkID     , <UInt32>
#  field currentPosition, <UInt64>
#  field logicalEOF , <UInt64>
#  field physicalEOF, <UInt64>
#  field process    , <UInt64>
#stoptype
#synonym_t FSForkInfoPtr, Ptr <FSForkInfo>

#starttype struct FSForkCBInfoParam
#  field qLink       , <QElemPtr>
#  field qType       , <SInt16>
#  field ioTrap      , <SInt16>
#  field ioCmdAddr   , <Ptr>
#  field ioCompletion, <IOCompletionUPP>
#  field ioResult    , <OSErr>
#  field desiredRefNum, <FSIORefNum>
#  field volumeRefNum, <FSVolumeRefNum>
#  field iterator    , <FSIORefNum>
#  field actualRefNum, <FSVolumeRefNum>
#  field ref         , Ptr <FSRef>
#  field forkInfo    , Ptr <FSForkInfo>
#  field forkName    , Ptr <HFSUniStr255>
#stoptype
#synonym_t FSForkCBInfoParamPtr, Ptr <FSForkCBInfoParam>

#starttype struct FSRangeLockParam
#  field qLink       , <QElemPtr>
#  field qType       , <SInt16>
#  field ioTrap      , <SInt16>
#  field ioCmdAddr   , <Ptr>
#  field ioCompletion, <IOCompletionUPP>
#  field ioResult    , <OSErr>
#  field forkRefNum  , <FSIORefNum>
#  field requestCount, <UInt64>
#  field positionMode, <UInt16>
#  field positionOffset, <SInt64>
#  field rangeStart  , <UInt64>
#stoptype
#synonym_t FSRangeLockParamPtr, Ptr <FSRangeLockParam>

#synonym_t FSVolumeInfoBitmap, <UInt32>
#num kFSVolInfoNone
#num kFSVolInfoCreateDate
#num kFSVolInfoModDate
#num kFSVolInfoBackupDate
#num kFSVolInfoCheckedDate
#num kFSVolInfoFileCount
#num kFSVolInfoSizes
#num kFSVolInfoBlocks
#num kFSVolInfoNextAlloc
#num kFSVolInfoRsrcClump
#num kFSVolInfoDataClump
#num kFSVolInfoNextID
#num kFSVolInfoFinderInfo
#num kFSVolInfoFlags
#num kFSVolInfoFSInfo
#num kFSVolInfoDriveInfo
#num kFSVolInfoGettableInfo
#num kFSVolInfoSettableInfo

#num kFSVolFlagDefaultVolumeBit
#num kFSVolFlagDefaultVolumeMask
#num kFSVolFlagFilesOpenBit
#num kFSVolFlagFilesOpenMask
#num kFSVolFlagHardwareLockedBit
#num kFSVolFlagHardwareLockedMask
#num kFSVolFlagJournalingActiveBit
#num kFSVolFlagJournalingActiveMask
#num kFSVolFlagSoftwareLockedBit
#num kFSVolFlagSoftwareLockedMask

#starttype struct FSVolumeInfo
#  field createDate , <UTCDateTime>
#  field modifyDate , <UTCDateTime>
#  field backupDate , <UTCDateTime>
#  field checkedDate, <UTCDateTime>
#  field fileCount  , <UInt32>
#  field folderCount, <UInt32>
#  field totalBytes , <UInt64>
#  field freeBytes  , <UInt64>
#  field blockSize  , <UInt32>
#  field totalBlocks, <UInt32>
#  field freeBlocks , <UInt32>
#  field nextAllocation  , <UInt32>
#  field rsrcClumpSize   , <UInt32>
#  field dataClumpSize   , <UInt32>
#  field nextCatalogID   , <UInt32>
#  array_field finderInfo, <UInt8>
#  field flags           , <UInt16>
#  field filesystemID    , <UInt16>
#  field signature       , <UInt16>
#  field driveNumber     , <UInt16>
#  field driverRefNum    , <FSIORefNum>
#stoptype
#synonym_t FSVolumeInfoPtr, Ptr <FSVolumeInfo>

#starttype struct FSVolumeInfoParam
#  field qLink       , <QElemPtr>
#  field qType       , <SInt16>
#  field ioTrap      , <SInt16>
#  field ioCmdAddr   , <Ptr>
#  field ioCompletion, <IOCompletionUPP>
#  field ioResult    , <OSErr>
#  field ioNamePtr   , <StringPtr>
#  field ioVRefNum   , <FSVolumeRefNum>
#  field volumeIndex , <UInt32>
#  field whichInfo   , <FSVolumeInfoBitmap>
#  field volumeInfo  , Ptr <FSVolumeInfo>
#  field volumeName  , Ptr <HFSUniStr255>
#  field ref         , Ptr <FSRef>
#stoptype
#synonym_t FSVolumeInfoParamPtr, Ptr <FSVolumeInfoParam>

#starttype struct GetVolParmsInfoBuffer
#  field vMVersion  , <SInt16>
#  field vMAttrib   , <SInt32>
#  field vMLocalHand, <Handle>
#  field vMServerAdr, <SInt32>
#  field vMVolumeGrade       , <SInt32>
#  field vMForeignPrivID     , <SInt16>
#  field vMExtendedAttributes, <SInt32>
#  field vMDeviceID          , Ptr ()
#  field vMMaxNameLength     , <UniCharCount>
#stoptype

#synonym_t VolumeType, <OSType>
#num AppleShareMediaType

#starttype struct VolMountInfoHeader
#  field length, <SInt16>
#  field media , <VolumeType>
#stoptype
#synonym_t VolMountInfoPtr, Ptr <VolMountInfoHeader>

#starttype struct VolumeMountInfoHeader
#  field length, <SInt16>
#  field media , <VolumeType>
#  field flags , <SInt16>
#stoptype
#synonym_t VolumeMountInfoHeaderPtr, Ptr <VolumeMountInfoHeader>

#num volMountNoLoginMsgFlagBit
#num volMountNoLoginMsgFlagMask
#num volMountExtendedFlagsBit
#num volMountExtendedFlagsMask
#num volMountInteractBit
#num volMountInteractMask
#num volMountChangedBit
#num volMountChangedMask
#num volMountFSReservedMask
#num volMountSysReservedMask

#starttype struct AFPVolMountInfo
#  field length            , <SInt16>
#  field media             , <VolumeType>
#  field flags             , <SInt16>
#  field nbpInterval       , <SInt8>
#  field nbpCount          , <SInt8>
#  field uamType           , <SInt16>
#  field zoneNameOffset    , <SInt16>
#  field serverNameOffset  , <SInt16>
#  field volNameOffset     , <SInt16>
#  field userNameOffset    , <SInt16>
#  field userPasswordOffset, <SInt16>
#  field volPasswordOffset , <SInt16>
#  array_field AFPData     , CChar
#stoptype
#synonym_t AFPVolMountInfoPtr, Ptr <AFPVolMountInfo>

#num kAFPExtendedFlagsAlternateAddressMask

#num kAFPTagTypeIP
#num kAFPTagTypeIPPort
#num kAFPTagTypeDDP
#num kAFPTagTypeDNS

#num kAFPTagLengthIP
#num kAFPTagLengthIPPort
#num kAFPTagLengthDDP

#starttype struct AFPTagData
#  field fLength, <UInt8>
#  field fType  , <UInt8>
#  flexible_array_member fData, <UInt8>
#stoptype

#starttype struct AFPAlternateAddress
#  field fVersion     , <UInt8>
#  field fAddressCount, <UInt8>
#  flexible_array_member fAddressList, <UInt8>
#stoptype

#num kLargeIconSize
#num kLarge4BitIconSize
#num kLarge8BitIconSize
#num kSmallIconSize
#num kSmall4BitIconSize
#num kSmall8BitIconSize

#ccall FSMakeFSRefUnicode      , Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> <TextEncoding> -> Ptr <FSRef> -> IO <OSErr>
#ccall PBMakeFSRefUnicodeSync  , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBMakeFSRefUnicodeAsync , Ptr <FSRefParam> -> IO ()
#ccall FSCompareFSRefs         , Ptr <FSRef> -> Ptr <FSRef> -> IO <OSErr>
#ccall PBCompareFSRefsSync     , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBCompareFSRefsAsync    , Ptr <FSRefParam> -> IO ()
#ccall FSCreateFileUnicode     , Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> <FSCatalogInfoBitmap> -> Ptr <FSCatalogInfo> -> Ptr <FSRef> -> <FSSpecPtr> -> IO <OSErr>
#ccall PBCreateFileUnicodeSync , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBCreateFileUnicodeAsync, Ptr <FSRefParam> -> IO ()
#ccall FSCreateDirectoryUnicode, Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> <FSCatalogInfoBitmap> -> Ptr <FSCatalogInfo> -> Ptr <FSRef> -> <FSSpecPtr> -> Ptr <UInt32> -> IO <OSErr>
#ccall PBCreateDirectoryUnicodeSync , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBCreateDirectoryUnicodeAsync, Ptr <FSRefParam> -> IO ()
#ccall FSDeleteObject          , Ptr <FSRef> -> IO <OSErr>
#ccall PBDeleteObjectSync      , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBDeleteObjectAsync     , Ptr <FSRefParam> -> IO ()
#ccall FSUnlinkObject          , Ptr <FSRef> -> IO <OSErr>
#ccall PBUnlinkObjectSync      , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBUnlinkObjectAsync     , Ptr <FSRefParam> -> IO ()
#ccall FSMoveObject            , Ptr <FSRef> -> Ptr <FSRef> -> Ptr <FSRef> -> IO <OSErr>
#ccall PBMoveObjectSync        , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBMoveObjectAsync       , Ptr <FSRefParam> -> IO ()
#ccall FSExchangeObjects       , Ptr <FSRef> -> Ptr <FSRef> -> IO <OSErr>
#ccall PBExchangeObjectsSync   , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBExchangeObjectsAsync  , Ptr <FSRefParam> -> IO ()

#num kFSReplaceObjectDefaultOptions
#num kFSReplaceObjectReplaceMetadata
#num kFSReplaceObjectSaveOriginalAsABackup
#num kFSReplaceObjectReplacePermissionInfo
#num kFSReplaceObjectPreservePermissionInfo
#num kFSReplaceObjectDoNotCheckObjectWriteAccess

#ccall FSReplaceObject      , Ptr <FSRef> -> Ptr <FSRef> -> <CFStringRef> -> <CFStringRef> -> Ptr <FSRef> -> <OptionBits> -> Ptr <FSRef> -> IO <OSStatus>
#ccall FSPathReplaceObject  , Ptr CChar -> Ptr CChar -> <CFStringRef> -> <CFStringRef> -> Ptr CChar -> <OptionBits> -> IO <OSStatus>
#ccall FSGetTemporaryDirectoryForReplaceObject    , Ptr <FSRef> -> Ptr <FSRef> -> <OptionBits> -> IO <OSStatus>
#ccall FSPathGetTemporaryDirectoryForReplaceObject, Ptr CChar -> Ptr CChar -> <UInt32> -> <OptionBits> -> IO <OSStatus>
#ccall FSRenameUnicode      , Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> <TextEncoding> -> Ptr <FSRef> -> IO <OSErr>
#ccall PBRenameUnicodeSync  , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBRenameUnicodeAsync , Ptr <FSRefParam> -> IO ()
#ccall FSGetCatalogInfo     , Ptr <FSRef> -> <FSCatalogInfoBitmap> -> Ptr <FSCatalogInfo> -> Ptr <HFSUniStr255> -> <FSSpecPtr> -> Ptr <FSRef> -> IO <OSErr>
#ccall PBGetCatalogInfoSync , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBGetCatalogInfoAsync, Ptr <FSRefParam> -> IO ()
#ccall FSSetCatalogInfo     , Ptr <FSRef> -> <FSCatalogInfoBitmap> -> Ptr <FSCatalogInfo> -> IO <OSErr>
#ccall PBSetCatalogInfoSync , Ptr <FSRefParam> -> IO <OSErr>
#ccall PBSetCatalogInfoAsync, Ptr <FSRefParam> -> IO ()
#ccall FSOpenIterator       , Ptr <FSRef> -> <FSIteratorFlags> -> Ptr <FSIterator> -> IO <OSErr>
#ccall PBOpenIteratorSync   , Ptr <FSCatalogBulkParam> -> IO <OSErr>
#ccall PBOpenIteratorAsync  , Ptr <FSCatalogBulkParam> -> IO ()
#ccall FSCloseIterator      , <FSIterator> -> IO <OSErr>
#ccall PBCloseIteratorSync  , Ptr <FSCatalogBulkParam> -> IO <OSErr>
#ccall PBCloseIteratorAsync , Ptr <FSCatalogBulkParam> -> IO ()
#ccall FSGetCatalogInfoBulk , <FSIterator> -> <ItemCount> -> Ptr <ItemCount> -> Ptr <Boolean> -> <FSCatalogInfoBitmap> -> Ptr <FSCatalogInfo> -> Ptr <FSRef> -> <FSSpecPtr> -> Ptr <HFSUniStr255> -> IO <OSErr>
#ccall PBGetCatalogInfoBulkSync , Ptr <FSCatalogBulkParam> -> IO <OSErr>
#ccall PBGetCatalogInfoBulkAsync, Ptr <FSCatalogBulkParam> -> IO ()
#ccall FSCatalogSearch      , <FSIterator> -> Ptr <FSSearchParams> -> <ItemCount> -> Ptr <ItemCount> -> Ptr <Boolean> -> <FSCatalogBulkParam> -> Ptr <FSCatalogInfo> -> Ptr <FSRef> -> <FSSpecPtr> -> Ptr <HFSUniStr255> -> IO <OSErr>
#ccall PBCatalogSearchSync  , Ptr <FSCatalogBulkParam> -> IO <OSErr>
#ccall PBCatalogSearchAsync , Ptr <FSCatalogBulkParam> -> IO ()
#ccall FSCreateFileAndOpenForkUnicode     , Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> <FSCatalogInfoBitmap> -> Ptr <FSCatalogInfo> -> <UniCharCount> -> Ptr <UniChar> -> <SInt8> -> Ptr <FSIORefNum> -> Ptr <FSRef> -> IO <OSStatus>
#ccall PBCreateFileAndOpenForkUnicodeSync , <FSRefForkIOParamPtr> -> IO <OSStatus>
#ccall PBCreateFileAndOpenForkUnicodeAsync, <FSRefForkIOParamPtr> -> IO ()
#ccall FSCreateFork         , Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> IO <OSErr>
#ccall PBCreateForkSync     , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBCreateForkAsync    , Ptr <FSForkIOParam> -> IO ()
#ccall FSDeleteFork         , Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> IO <OSErr>
#ccall PBDeleteForkSync     , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBDeleteForkAsync    , Ptr <FSForkIOParam> -> IO ()
#ccall FSIterateForks       , Ptr <FSRef> -> Ptr <CatPositionRec> -> Ptr <HFSUniStr255> -> Ptr <SInt64> -> Ptr <UInt64> -> IO <OSErr>
#ccall PBIterateForksSync   , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBIterateForksAsync  , Ptr <FSForkIOParam> -> IO ()
#ccall FSOpenFork           , Ptr <FSRef> -> <UniCharCount> -> Ptr <UniChar> -> <SInt8> -> Ptr <FSIORefNum> -> IO <OSErr>
#ccall PBOpenForkSync       , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBOpenForkAsync      , Ptr <FSForkIOParam> -> IO ()
#ccall FSReadFork           , <FSIORefNum> -> <UInt16> -> <SInt64> -> <ByteCount> -> Ptr () -> Ptr <ByteCount> -> IO <OSErr>
#ccall PBReadForkSync       , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBReadForkAsync      , Ptr <FSForkIOParam> -> IO ()
#ccall FSWriteFork          , <FSIORefNum> -> <UInt16> -> <SInt64> -> <ByteCount> -> Ptr () -> Ptr <ByteCount> -> IO <OSErr>
#ccall PBWriteForkSync      , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBWriteForkAsync     , Ptr <FSForkIOParam> -> IO ()
#ccall FSGetForkPosition    , <FSIORefNum> -> Ptr <SInt64> -> IO <OSErr>
#ccall PBGetForkPositionSync, Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBGetForkPositionAsync, Ptr <FSForkIOParam> -> IO ()
#ccall FSSetForkPosition    , <FSIORefNum> -> <UInt16> -> <SInt64> -> IO <OSErr>
#ccall PBSetForkPositionSync, Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBSetForkPositionAsync, Ptr <FSForkIOParam> -> IO ()
#ccall FSGetForkSize        , <FSIORefNum> -> Ptr <SInt64> -> IO <OSErr>
#ccall PBGetForkSizeSync    , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBGetForkSizeAsync   , Ptr <FSForkIOParam> -> IO ()
#ccall FSSetForkSize        , <FSIORefNum> -> <UInt16> -> <SInt64> -> IO <OSErr>
#ccall PBSetForkSizeSync    , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBSetForkSizeAsync   , Ptr <FSForkIOParam> -> IO ()
#ccall FSAllocateFork       , <FSIORefNum> -> <FSAllocationFlags> -> <UInt16> -> <SInt64> -> <UInt64> -> Ptr <UInt64> -> IO <OSErr>
#ccall PBAllocateForkSync   , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBAllocateForkAsync  , Ptr <FSForkIOParam> -> IO ()
#ccall FSFlushFork          , <FSIORefNum> -> IO <OSErr>
#ccall PBFlushForkSync      , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBFlushForkAsync     , Ptr <FSForkIOParam> -> IO ()
#ccall FSCloseFork          , <FSIORefNum> -> IO <OSErr>
#ccall PBCloseForkSync      , Ptr <FSForkIOParam> -> IO <OSErr>
#ccall PBCloseForkAsync     , Ptr <FSForkIOParam> -> IO ()
#ccall FSGetForkCBInfo      , <FSIORefNum> -> <FSVolumeRefNum> -> Ptr CShort -> Ptr <FSIORefNum> -> Ptr <FSForkInfo> -> Ptr <FSRef> -> Ptr <HFSUniStr255> -> IO <OSErr>
#ccall PBGetForkCBInfoSync  , Ptr <FSForkCBInfoParam> -> IO <OSErr>
#ccall PBGetForkCBInfoAsync , Ptr <FSForkCBInfoParam> -> IO ()
#ccall FSLockRange          , <FSIORefNum> -> <UInt16> -> <SInt64> -> <UInt64> -> Ptr <UInt64> -> IO <OSErr>
#ccall PBXLockRangeSync     , <FSRangeLockParamPtr> -> IO <OSErr>
#ccall PBXLockRangeAsync    , <FSRangeLockParamPtr> -> IO <OSStatus>
#ccall FSUnlockRange        , <FSIORefNum> -> <UInt16> -> <SInt64> -> <UInt64> -> Ptr <UInt64> -> IO <OSStatus>
#ccall PBXUnlockRangeSync   , <FSRangeLockParamPtr> -> IO <OSStatus>
#ccall PBXUnlockRangeAsync  , <FSRangeLockParamPtr> -> IO <OSStatus>
#ccall FSGetVolumeInfo      , <FSVolumeRefNum> -> <ItemCount> -> Ptr <FSVolumeRefNum> -> <FSVolumeInfoBitmap> -> Ptr <FSVolumeInfo> -> Ptr <HFSUniStr255> -> Ptr <FSRef> -> IO <OSErr>
#ccall PBGetVolumeInfoSync  , Ptr <FSVolumeInfoParam> -> IO <OSErr>
#ccall PBGetVolumeInfoAsync , Ptr <FSVolumeInfoParam> -> IO ()
#ccall FSSetVolumeInfo      , <FSVolumeRefNum> -> <FSVolumeInfoBitmap> -> Ptr <FSVolumeInfo> -> IO <OSErr>
#ccall PBSetVolumeInfoSync  , Ptr <FSVolumeInfoParam> -> IO <OSErr>
#ccall PBSetVolumeInfoAsync , Ptr <FSVolumeInfoParam> -> IO ()
#ccall FSGetDataForkName    , Ptr <HFSUniStr255> -> IO <OSErr>
#ccall FSGetResourceForkName, Ptr <HFSUniStr255> -> IO <OSErr>
#ccall FSRefMakePath        , Ptr <FSRef> -> Ptr <UInt8> -> <UInt32> -> IO <OSStatus>
#ccall FSPathMakeRef        , Ptr <UInt8> -> Ptr <FSRef> -> Ptr <Boolean> -> IO <OSStatus>

#num kFSPathMakeRefDefaultOptions
#num kFSPathMakeRefDoNotFollowLeafSymlink

#ccall FSPathMakeRefWithOptions, Ptr <UInt8> -> <OptionBits> -> Ptr <FSRef> -> Ptr <Boolean> -> IO <OSStatus>
#ccall FSIsFSRefValid          , Ptr <FSRef> -> IO <Boolean>

#synonym_t FNMessage, <UInt32>
#num kFNDirectoryModifiedMessage

#ccall FNNotify      , Ptr <FSRef> -> <FNMessage> -> <OptionBits> -> IO <OSStatus>
#ccall FNNotifyByPath, Ptr <UInt8> -> <FNMessage> -> <OptionBits> -> IO <OSStatus>
#ccall FNNotifyAll   , <FNMessage> -> <OptionBits> -> IO <OSStatus>

#opaque_t  OpaqueFNSubscriptionRef
#synonym_t FNSubscriptionRef, Ptr <OpaqueFNSubscriptionRef>

#num kFNNoImplicitAllSubscription
#num kFNNotifyInBackground

#callback  FNSubscriptionProcPtr, <FNMessage> -> <OptionBits> -> Ptr () -> <FNSubscriptionRef> -> IO ()
#synonym_t FNSubscriptionUPP    , <FNSubscriptionProcPtr>

#ccall FNSubscribe      , Ptr <FSRef> -> <FNSubscriptionUPP> -> Ptr () -> <OptionBits> -> Ptr <FNSubscriptionRef> -> IO <OSStatus>
#ccall FNSubscribeByPath, Ptr <UInt8> -> <FNSubscriptionUPP> -> Ptr () -> <OptionBits> -> Ptr <FNSubscriptionRef> -> IO <OSStatus>
#ccall FNUnsubscribe    , <FNSubscriptionRef> -> IO <OSStatus>
#ccall FNGetDirectoryForSubscription, <FNSubscriptionRef> -> Ptr <FSRef> -> IO <OSStatus>

#num kAsyncMountInProgress
#num kAsyncMountComplete
#num kAsyncUnmountInProgress
#num kAsyncUnmountComplete
#num kAsyncEjectInProgress
#num kAsyncEjectComplete

#synonym_t FSMountStatus    , <UInt32>
#synonym_t FSEjectStatus    , <UInt32>
#synonym_t FSUnmountStatus  , <UInt32>
#opaque_t  OpaqueFSVolumeOperation
#synonym_t FSVolumeOperation     , Ptr <OpaqueFSVolumeOperation>
#callback  FSVolumeMountProcPtr  , <FSVolumeOperation> -> Ptr () -> <OSStatus> -> <FSVolumeRefNum> -> IO ()
#callback  FSVolumeUnmountProcPtr, <FSVolumeOperation> -> Ptr () -> <OSStatus> -> <FSVolumeRefNum> -> CPid -> IO ()
#callback  FSVolumeEjectProcPtr  , <FSVolumeOperation> -> Ptr () -> <OSStatus> -> <FSVolumeRefNum> -> CPid -> IO ()
#synonym_t FSVolumeMountUPP      , <FSVolumeMountProcPtr>
#synonym_t FSVolumeUnmountUPP    , <FSVolumeUnmountProcPtr>
#synonym_t FSVolumeEjectUPP      , <FSVolumeEjectProcPtr>

#num kFSMountServerMarkDoNotDisplay
#num kFSMountServerMountOnMountDir
#num kFSMountServerMountWithoutNotification
#num kFSEjectVolumeForceEject
#num kFSUnmountVolumeForceUnmount

#ccall FSCreateVolumeOperation , Ptr <FSVolumeOperation> -> IO <OSStatus>
#ccall FSDisposeVolumeOperation, <FSVolumeOperation> -> IO <OSStatus>
#ccall FSMountLocalVolumeSync  , <CFStringRef> -> <CFURLRef> -> Ptr <FSVolumeRefNum> -> <OptionBits> -> IO <OSStatus>
#ccall FSMountLocalVolumeAsync , <CFStringRef> -> <CFURLRef> -> <FSVolumeOperation> -> Ptr () -> <OptionBits> -> <FSVolumeMountUPP> -> <CFRunLoopRef> -> <CFStringRef> -> IO <OSStatus>
#ccall FSMountServerVolumeSync , <CFURLRef> -> <CFURLRef> -> <CFStringRef> -> <CFStringRef> -> Ptr <FSVolumeRefNum> -> <OptionBits> -> IO <OSStatus>
#ccall FSMountServerVolumeAsync, <CFURLRef> -> <CFURLRef> -> <CFStringRef> -> <CFStringRef> -> <FSVolumeOperation> -> Ptr () -> <OptionBits> -> <FSVolumeMountUPP> -> <CFRunLoopRef> -> <CFStringRef> -> IO <OSStatus>
#ccall FSGetAsyncMountStatus   , <FSVolumeOperation> -> Ptr <FSMountStatus> -> Ptr <OSStatus> -> Ptr <FSVolumeRefNum> -> Ptr (Ptr ()) -> IO <OSStatus>
#ccall FSUnmountVolumeSync     , <FSVolumeRefNum> -> <OptionBits> -> Ptr CPid -> IO <OSStatus>
#ccall FSUnmountVolumeAsync    , <FSVolumeRefNum> -> <OptionBits> -> <FSVolumeOperation> -> Ptr () -> <FSVolumeUnmountUPP> -> <CFRunLoopRef> -> <CFStringRef> -> IO <OSStatus>
#ccall FSGetAsyncUnmountStatus , <FSVolumeOperation> -> Ptr <FSUnmountStatus> -> Ptr <OSStatus> -> Ptr <FSVolumeRefNum> -> Ptr CPid -> Ptr (Ptr ()) -> IO <OSStatus>
#ccall FSCancelVolumeOperation , <FSVolumeOperation> -> IO <OSStatus>
#ccall FSEjectVolumeSync       , <FSVolumeRefNum> -> <OptionBits> -> Ptr CPid -> IO <OSStatus>
#ccall FSEjectVolumeAsync      , <FSVolumeRefNum> -> <OptionBits> -> <FSVolumeOperation> -> Ptr () -> <FSVolumeEjectUPP> -> <CFRunLoopRef> -> <CFStringRef> -> IO <OSStatus>
#ccall FSGetAsyncEjectStatus   , <FSVolumeOperation> -> Ptr <FSEjectStatus> -> Ptr <OSStatus> -> Ptr <FSVolumeRefNum> -> Ptr CPid -> Ptr (Ptr ()) -> IO <OSStatus>
#ccall FSCopyDiskIDForVolume   , <FSVolumeRefNum> -> Ptr <CFStringRef> -> IO <OSStatus>
#ccall FSCopyURLForVolume      , <FSVolumeRefNum> -> Ptr <CFURLRef> -> IO <OSStatus>
#ccall FSGetVolumeForDiskID    , <CFStringRef> -> Ptr <FSVolumeRefNum> -> IO <OSStatus>
#ccall FSCopyDADiskForVolume   , <FSVolumeRefNum> -> Ptr <DADiskRef> -> IO <OSStatus>
#ccall FSGetVolumeForDADisk    , <DADiskRef> -> Ptr <FSVolumeRefNum> -> IO <OSStatus>

#opaque_t  __FSFileOperation
#synonym_t FSFileOperationRef  , Ptr <__FSFileOperation>
#synonym_t FSFileOperationStage, <UInt32>

#starttype struct FSFileOperationClientContext
#  field version, <CFIndex>
#  field info   , Ptr ()
#  field retain , <CFAllocatorRetainCallBack>
#  field release, <CFAllocatorReleaseCallBack>
#  field copyDescription, <CFAllocatorCopyDescriptionCallBack>
#stoptype

#callback FSFileOperationStatusProcPtr    , <FSFileOperationRef> -> Ptr <FSRef> -> <FSFileOperationStage> -> <OSStatus> -> <CFDictionaryRef> -> Ptr () -> IO ()
#callback FSPathFileOperationStatusProcPtr, <FSFileOperationRef> -> Ptr CChar -> <FSFileOperationStage> -> <OSStatus> -> <CFDictionaryRef> -> Ptr () -> IO ()

#num kFSFileOperationDefaultOptions
#num kFSFileOperationOverwrite
#num kFSFileOperationSkipSourcePermissionErrors
#num kFSFileOperationDoNotMoveAcrossVolumes
#num kFSFileOperationSkipPreflight

#num kFSOperationStageUndefined
#num kFSOperationStagePreflighting
#num kFSOperationStageRunning
#num kFSOperationStageComplete

#cinline kFSOperationTotalBytesKey      , IO <CFStringRef>
#cinline kFSOperationBytesCompleteKey   , IO <CFStringRef>
#cinline kFSOperationBytesRemainingKey  , IO <CFStringRef>
#cinline kFSOperationTotalObjectsKey    , IO <CFStringRef>
#cinline kFSOperationObjectsCompleteKey , IO <CFStringRef>
#cinline kFSOperationObjectsRemainingKey, IO <CFStringRef>
#cinline kFSOperationTotalUserVisibleObjectsKey    , IO <CFStringRef>
#cinline kFSOperationUserVisibleObjectsCompleteKey , IO <CFStringRef>
#cinline kFSOperationUserVisibleObjectsRemainingKey, IO <CFStringRef>
#cinline kFSOperationThroughputKey      , IO <CFStringRef>

#ccall FSCopyObjectSync       , Ptr <FSRef> -> Ptr <FSRef> -> <CFStringRef> -> Ptr <FSRef> -> <OptionBits> -> IO <OSStatus>
#ccall FSMoveObjectSync       , Ptr <FSRef> -> Ptr <FSRef> -> <CFStringRef> -> Ptr <FSRef> -> <OptionBits> -> IO <OSStatus>
#ccall FSMoveObjectToTrashSync, Ptr <FSRef> -> Ptr <FSRef> -> <OptionBits> -> IO <OSStatus>
#ccall FSPathCopyObjectSync   , Ptr CChar -> Ptr CChar -> <CFStringRef> -> Ptr (Ptr CChar) -> <OptionBits> -> IO <OSStatus>
#ccall FSPathMoveObjectSync   , Ptr CChar -> Ptr CChar -> <CFStringRef> -> Ptr (Ptr CChar) -> <OptionBits> -> IO <OSStatus>
#ccall FSPathMoveObjectToTrashSync, Ptr CChar -> Ptr (Ptr CChar) -> <OptionBits> -> IO <OSStatus>
#ccall FSFileOperationGetTypeID   , IO <CFTypeID>
#ccall FSFileOperationCreate  , <CFAllocatorRef> -> IO <FSFileOperationRef>
#ccall FSFileOperationScheduleWithRunLoop  , <FSFileOperationRef> -> <CFRunLoopRef> -> <CFStringRef> -> IO <OSStatus>
#ccall FSFileOperationUnscheduleFromRunLoop, <FSFileOperationRef> -> <CFRunLoopRef> -> <CFStringRef> -> IO <OSStatus>
#ccall FSCopyObjectAsync      , <FSFileOperationRef> -> Ptr <FSRef> -> Ptr <FSRef> -> <CFStringRef> -> <OptionBits> -> <FSFileOperationStatusProcPtr> -> <CFTimeInterval> -> Ptr <FSFileOperationClientContext> -> IO <OSStatus>
#ccall FSMoveObjectAsync      , <FSFileOperationRef> -> Ptr <FSRef> -> Ptr <FSRef> -> <CFStringRef> -> <OptionBits> -> <FSFileOperationStatusProcPtr> -> <CFTimeInterval> -> Ptr <FSFileOperationClientContext> -> IO <OSStatus>
#ccall FSMoveObjectToTrashAsync, <FSFileOperationRef> -> Ptr <FSRef> -> <OptionBits> -> <FSFileOperationStatusProcPtr> -> <CFTimeInterval> -> Ptr <FSFileOperationClientContext> -> IO <OSStatus>
#ccall FSPathCopyObjectAsync  , <FSFileOperationRef> -> Ptr CChar -> Ptr CChar -> <CFStringRef> -> <OptionBits> -> <FSPathFileOperationStatusProcPtr> -> <CFTimeInterval> -> Ptr <FSFileOperationClientContext> -> IO <OSStatus>
#ccall FSPathMoveObjectAsync  , <FSFileOperationRef> -> Ptr CChar -> Ptr CChar -> <CFStringRef> -> <OptionBits> -> <FSPathFileOperationStatusProcPtr> -> <CFTimeInterval> -> Ptr <FSFileOperationClientContext> -> IO <OSStatus>
#ccall FSPathMoveObjectToTrashAsync, <FSFileOperationRef> -> Ptr CChar -> <OptionBits> -> <FSPathFileOperationStatusProcPtr> -> <CFTimeInterval> -> Ptr <FSFileOperationClientContext> -> IO <OSStatus>
#ccall FSFileOperationCancel  , <FSFileOperationRef> -> IO <OSStatus>
#ccall FSFileOperationCopyStatus    , <FSFileOperationRef> -> Ptr <FSRef> -> Ptr <FSFileOperationStage> -> Ptr <OSStatus> -> Ptr <CFDictionaryRef> -> Ptr (Ptr ()) -> IO <OSStatus>
#ccall FSPathFileOperationCopyStatus, <FSFileOperationRef> -> Ptr (Ptr CChar) -> Ptr <FSFileOperationStage> -> Ptr <OSStatus> -> Ptr <CFDictionaryRef> -> Ptr (Ptr ()) -> IO <OSStatus>
#ccall FSCreateStringFromHFSUniStr  , <CFAllocatorRef> -> Ptr <HFSUniStr255> -> IO <CFStringRef>
#ccall FSGetHFSUniStrFromString     , <CFStringRef> -> Ptr <HFSUniStr255> -> IO <OSStatus>
#ccall FSFileSecurityGetTypeID      , IO <CFTypeID>
#ccall FSFileSecurityCreate         , <CFAllocatorRef> -> IO <FSFileSecurityRef>
#ccall FSFileSecurityCreateWithFSPermissionInfo, <CFAllocatorRef> -> Ptr <FSPermissionInfo> -> IO <FSFileSecurityRef>
#ccall FSFileSecurityRefCreateCopy  , <CFAllocatorRef> -> <FSFileSecurityRef> -> IO <FSFileSecurityRef>
#ccall FSFileSecurityGetOwnerUUID   , <FSFileSecurityRef> -> Ptr <CFUUIDBytes> -> IO <OSStatus>
#ccall FSFileSecuritySetOwnerUUID   , <FSFileSecurityRef> -> Ptr <CFUUIDBytes> -> IO <OSStatus>
#ccall FSFileSecurityGetGroupUUID   , <FSFileSecurityRef> -> Ptr <CFUUIDBytes> -> IO <OSStatus>
#ccall FSFileSecuritySetGroupUUID   , <FSFileSecurityRef> -> Ptr <CFUUIDBytes> -> IO <OSStatus>
#ccall FSFileSecurityCopyAccessControlList, <FSFileSecurityRef> -> <acl_t> -> IO <OSStatus>
#ccall FSFileSecuritySetAccessControlList , <FSFileSecurityRef> -> <acl_t> -> IO <OSStatus>
#ccall FSFileSecurityGetOwner       , <FSFileSecurityRef> -> Ptr <UInt32> -> IO <OSStatus>
#ccall FSFileSecuritySetOwner       , <FSFileSecurityRef> -> <UInt32> -> IO <OSStatus>
#ccall FSFileSecurityGetGroup       , <FSFileSecurityRef> -> Ptr <UInt32> -> IO <OSStatus>
#ccall FSFileSecuritySetGroup       , <FSFileSecurityRef> -> <UInt32> -> IO <OSStatus>
#ccall FSFileSecurityGetMode        , <FSFileSecurityRef> -> Ptr <UInt16> -> IO <OSStatus>
#ccall FSFileSecuritySetMode        , <FSFileSecurityRef> -> <UInt16> -> IO <OSStatus>

#num pleaseCacheBit
#num pleaseCacheMask
#num noCacheBit
#num noCacheMask
#num rdVerifyBit
#num rdVerifyMask
#num rdVerify
#num forceReadBit
#num forceReadMask
#num newLineBit
#num newLineMask
#num newLineCharMask

#num kOwnerID2Name
#num kGroupID2Name
#num kOwnerName2ID
#num kGroupName2ID
#num kReturnNextUser
#num kReturnNextGroup
#num kReturnNextUG

#num kVCBFlagsIdleFlushBit
#num kVCBFlagsIdleFlushMask
#num kVCBFlagsHFSPlusAPIsBit
#num kVCBFlagsHFSPlusAPIsMask
#num kVCBFlagsHardwareGoneBit
#num kVCBFlagsHardwareGoneMask
#num kVCBFlagsVolumeDirtyBit
#num kVCBFlagsVolumeDirtyMask

#num kioVAtrbDefaultVolumeBit
#num kioVAtrbDefaultVolumeMask
#num kioVAtrbFilesOpenBit
#num kioVAtrbFilesOpenMask
#num kioVAtrbHardwareLockedBit
#num kioVAtrbHardwareLockedMask
#num kioVAtrbSoftwareLockedBit
#num kioVAtrbSoftwareLockedMask

#num kioFlAttribLockedBit
#num kioFlAttribLockedMask
#num kioFlAttribResOpenBit
#num kioFlAttribResOpenMask
#num kioFlAttribDataOpenBit
#num kioFlAttribDataOpenMask
#num kioFlAttribDirBit
#num kioFlAttribDirMask
#num ioDirFlg
#num ioDirMask
#num kioFlAttribCopyProtBit
#num kioFlAttribCopyProtMask
#num kioFlAttribFileOpenBit
#num kioFlAttribFileOpenMask
#num kioFlAttribInSharedBit
#num kioFlAttribInSharedMask
#num kioFlAttribMountedBit
#num kioFlAttribMountedMask
#num kioFlAttribSharePointBit
#num kioFlAttribSharePointMask

#num kioFCBWriteBit
#num kioFCBWriteMask
#num kioFCBResourceBit
#num kioFCBResourceMask
#num kioFCBWriteLockedBit
#num kioFCBWriteLockedMask
#num kioFCBLargeFileBit
#num kioFCBLargeFileMask
#num kioFCBSharedWriteBit
#num kioFCBSharedWriteMask
#num kioFCBFileLockedBit
#num kioFCBFileLockedMask
#num kioFCBOwnClumpBit
#num kioFCBOwnClumpMask
#num kioFCBModifiedBit
#num kioFCBModifiedMask

#num kioACUserNoSeeFolderBit
#num kioACUserNoSeeFolderMask
#num kioACUserNoSeeFilesBit
#num kioACUserNoSeeFilesMask
#num kioACUserNoMakeChangesBit
#num kioACUserNoMakeChangesMask
#num kioACUserNotOwnerBit
#num kioACUserNotOwnerMask

#num kioACAccessOwnerBit
#num kioACAccessOwnerMask
#num kioACAccessBlankAccessBit
#num kioACAccessBlankAccessMask
#num kioACAccessUserWriteBit
#num kioACAccessUserWriteMask
#num kioACAccessUserReadBit
#num kioACAccessUserReadMask
#num kioACAccessUserSearchBit
#num kioACAccessUserSearchMask
#num kioACAccessEveryoneWriteBit
#num kioACAccessEveryoneWriteMask
#num kioACAccessEveryoneReadBit
#num kioACAccessEveryoneReadMask
#num kioACAccessEveryoneSearchBit
#num kioACAccessEveryoneSearchMask
#num kioACAccessGroupWriteBit
#num kioACAccessGroupWriteMask
#num kioACAccessGroupReadBit
#num kioACAccessGroupReadMask
#num kioACAccessGroupSearchBit
#num kioACAccessGroupSearchMask
#num kioACAccessOwnerWriteBit
#num kioACAccessOwnerWriteMask
#num kioACAccessOwnerReadBit
#num kioACAccessOwnerReadMask
#num kioACAccessOwnerSearchBit
#num kioACAccessOwnerSearchMask
#num kfullPrivileges
#num kownerPrivileges

#ccall FSGetVolumeParms        , <FSVolumeRefNum> -> Ptr <GetVolParmsInfoBuffer> -> <ByteCount> -> IO <OSStatus>
#ccall FSGetVolumeMountInfoSize, <FSVolumeRefNum> -> Ptr <ByteCount> -> IO <OSStatus>
#ccall FSGetVolumeMountInfo    , <FSVolumeRefNum> -> <BytePtr> -> <ByteCount> -> Ptr <ByteCount> -> IO <OSStatus>
#ccall FSVolumeMount           , <BytePtr> -> Ptr <FSVolumeRefNum> -> IO <OSStatus>
#ccall FSFlushVolume           , <FSVolumeRefNum> -> IO <OSStatus>
#ccall PBFlushVolumeSync       , <FSRefParamPtr> -> IO <OSStatus>
#ccall PBFlushVolumeAsync      , <FSRefParamPtr> -> IO <OSStatus>
#ccall PBFSCopyFileSync        , <FSRefParamPtr> -> IO <OSStatus>
#ccall PBFSCopyFileAsync       , <FSRefParamPtr> -> IO <OSStatus>
#ccall FSResolveNodeID         , <FSVolumeRefNum> -> <UInt32> -> <FSRefPtr> -> IO <OSStatus>
#ccall PBFSResolveNodeIDSync   , <FSRefParamPtr> -> IO <OSStatus>
#ccall PBFSResolveNodeIDAsync  , <FSRefParamPtr> -> IO <OSStatus>

#if !__LP64__
#  ccall FSpMakeFSRef    , Ptr <FSSpec> -> Ptr <FSRef> -> IO <OSErr>
#  ccall PBMakeFSRefSync , Ptr <FSRefParam> -> IO <OSErr>
#  ccall PBMakeFSRefAsync, Ptr <FSRefParam> -> IO ()
#  ccall PBCloseSync     , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBCloseAsync    , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBReadSync      , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBReadAsync     , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBWriteSync     , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBWriteAsync    , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBWaitIOComplete, <ParmBlkPtr> -> <Duration> -> IO <OSErr>
#  ccall PBHGetVolParmsSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetVolParmsAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBGetVolMountInfoSize, <ParmBlkPtr> -> IO <OSErr>
#  ccall PBGetVolMountInfo    , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBVolumeMount        , <ParmBlkPtr> -> IO <OSErr>
#  ccall FlushVol             , <ConstStr63Param> -> <FSVolumeRefNum> -> IO <OSErr>
#  ccall PBFlushVolSync       , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBFlushVolAsync      , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenDenySync      , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenDenyAsync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenRFDenySync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenRFDenyAsync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetDirAccessSync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetDirAccessAsync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHSetDirAccessSync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHSetDirAccessAsync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHMapIDSync         , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHMapIDAsync        , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHMapNameSync       , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHMapNameAsync      , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHCopyFileSync      , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHCopyFileAsync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBCreateFileIDRefSync, <HParmBlkPtr> -> IO <OSErr>
#  ccall PBCreateFileIDRefAsync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBResolveFileIDRefSync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBResolveFileIDRefAsync, <HParmBlkPtr> -> IO <OSErr>
#  ccall PBDeleteFileIDRefSync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBDeleteFileIDRefAsync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBXGetVolInfoSync    , <XVolumeParamPtr> -> IO <OSErr>
#  ccall PBXGetVolInfoAsync   , <XVolumeParamPtr> -> IO <OSErr>
#  ccall PBAllocateSync       , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBAllocateAsync      , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBGetEOFSync         , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBGetEOFAsync        , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBSetEOFSync         , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBSetEOFAsync        , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBGetFPosSync        , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBGetFPosAsync       , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBSetFPosSync        , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBSetFPosAsync       , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBFlushFileSync      , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBFlushFileAsync     , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBUnmountVol         , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBCatSearchSync      , <CSParamPtr> -> IO <OSErr>
#  ccall PBCatSearchAsync     , <CSParamPtr> -> IO <OSErr>
#  ccall UnmountVol, <ConstStr63Param> -> <FSVolumeRefNum> -> IO <OSErr>
#  ccall HSetVol   , <ConstStr63Param> -> <FSVolumeRefNum> -> <SInt32> -> IO <OSErr>
#  ccall FSClose   , <FSIORefNum> -> IO <OSErr>
#  ccall FSRead    , <FSIORefNum> -> Ptr <SInt32> -> Ptr () -> IO <OSErr>
#  ccall FSWrite   , <FSIORefNum> -> Ptr <SInt32> -> Ptr () -> IO <OSErr>
#  ccall Allocate  , <FSIORefNum> -> Ptr <SInt32> -> IO <OSErr>
#  ccall GetEOF    , <FSIORefNum> -> Ptr <SInt32> -> IO <OSErr>
#  ccall SetEOF    , <FSIORefNum> -> <SInt32> -> IO <OSErr>
#  ccall GetFPos   , <FSIORefNum> -> Ptr <SInt32> -> IO <OSErr>
#  ccall SetFPos   , <FSIORefNum> -> <SInt16> -> <SInt32> -> IO <OSErr>
#  ccall GetVRefNum, <FSIORefNum> -> Ptr <FSVolumeRefNum> -> IO <OSErr>
#  ccall PBLockRangeSync   , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBLockRangeAsync  , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBUnlockRangeSync , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBUnlockRangeAsync, <ParmBlkPtr> -> IO <OSErr>
#  ccall PBHSetVolSync     , <WDPBPtr> -> IO <OSErr>
#  ccall PBHSetVolAsync    , <WDPBPtr> -> IO <OSErr>
#  ccall PBHGetVolSync     , <WDPBPtr> -> IO <OSErr>
#  ccall PBHGetVolAsync    , <WDPBPtr> -> IO <OSErr>
#  ccall PBCatMoveSync     , <CMovePBPtr> -> IO <OSErr>
#  ccall PBCatMoveAsync    , <CMovePBPtr> -> IO <OSErr>
#  ccall PBDirCreateSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBDirCreateAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBGetFCBInfoSync  , <FCBPBPtr> -> IO <OSErr>
#  ccall PBGetFCBInfoAsync , <FCBPBPtr> -> IO <OSErr>
#  ccall PBGetCatInfoSync  , <CInfoPBPtr> -> IO <OSErr>
#  ccall PBGetCatInfoAsync , <CInfoPBPtr> -> IO <OSErr>
#  ccall PBSetCatInfoSync  , <CInfoPBPtr> -> IO <OSErr>
#  ccall PBSetCatInfoAsync , <CInfoPBPtr> -> IO <OSErr>
#  ccall PBAllocContigSync , <ParmBlkPtr> -> IO <OSErr>
#  ccall PBAllocContigAsync, <ParmBlkPtr> -> IO <OSErr>
#  ccall PBSetVInfoSync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBSetVInfoAsync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetVInfoSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetVInfoAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenSync       , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenAsync      , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenRFSync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenRFAsync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenDFSync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHOpenDFAsync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHCreateSync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHCreateAsync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHDeleteSync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHDeleteAsync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHRenameSync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHRenameAsync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHRstFLockSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHRstFLockAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHSetFLockSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHSetFLockAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetFInfoSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetFInfoAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHSetFInfoSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHSetFInfoAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBMakeFSSpecSync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBMakeFSSpecAsync , <HParmBlkPtr> -> IO <OSErr>
#  ccall HGetVol    , <StringPtr> -> Ptr <FSVolumeRefNum> -> Ptr <SInt32> -> IO <OSErr>
#  ccall HOpen      , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> <SInt8> -> Ptr <FSIORefNum> -> IO <OSErr>
#  ccall HOpenDF    , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> <SInt8> -> Ptr <FSIORefNum> -> IO <OSErr>
#  ccall HOpenRF    , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> <SInt8> -> Ptr <FSIORefNum> -> IO <OSErr>
#  ccall AllocContig, <FSVolumeRefNum> -> Ptr <SInt32> -> IO <OSErr>
#  ccall HCreate    , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> <OSType> -> <OSType> -> IO <OSErr>
#  ccall DirCreate  , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> Ptr <SInt32> -> IO <OSErr>
#  ccall HDelete    , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> IO <OSErr>
#  ccall HGetFInfo  , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> Ptr <FInfo> -> IO <OSErr>
#  ccall HSetFInfo  , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> Ptr <FInfo> -> IO <OSErr>
#  ccall HSetFLock  , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> Ptr <OSErr>
#  ccall HRstFLock  , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> Ptr <OSErr>
#  ccall HRename    , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> <ConstStr255Param> -> IO <OSErr>
#  ccall CatMove    , <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> <SInt32> -> <ConstStr255Param> -> IO <OSErr>
#  ccall PBHGetLogInInfoSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHGetLogInInfoAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHMoveRenameSync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBHMoveRenameAsync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBGetXCatInfoSync     , <XCInfoPBPtr> -> IO <OSErr>
#  ccall PBGetXCatInfoAsync    , <XCInfoPBPtr> -> IO <OSErr>
#  ccall PBExchangeFilesSync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBExchangeFilesAsync  , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBGetForeignPrivsSync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBGetForeignPrivsAsync, <HParmBlkPtr> -> IO <OSErr>
#  ccall PBSetForeignPrivsSync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBSetForeignPrivsAsync, <HParmBlkPtr> -> IO <OSErr>
#endif

#if !__LP64__
#  num kLargeIcon
#  num kLarge4BitIcon
#  num kLarge8BitIcon
#  num kSmallIcon
#  num kSmall4BitIcon
#  num kSmall8BitIcon
#  num kicnsIconFamily
#endif

#if !__LP64__
#  ccall PBDTGetPath     , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTCloseDown   , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTAddIconSync , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTAddIconAsync, <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetIconSync , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetIconAsync, <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetIconInfoSync , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetIconInfoAsync, <DTPBPtr> -> IO <OSErr>
#  ccall PBDTAddAPPLSync     , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTAddAPPLAsync    , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTRemoveAPPLSync  , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTRemoveAPPLAsync , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetAPPLSync     , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetAPPLAsync    , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTSetCommentSync  , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTSetCommentAsync , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTRemoveCommentSync , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTRemoveCommentAsync, <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetCommentSync  , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetCommentAsync , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTFlushSync       , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTFlushAsync      , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTResetSync       , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTResetAsync      , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetInfoSync     , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTGetInfoAsync    , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTOpenInform      , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTDeleteSync      , <DTPBPtr> -> IO <OSErr>
#  ccall PBDTDeleteAsync     , <DTPBPtr> -> IO <OSErr>
#  ccall FSMakeFSSpec, <FSVolumeRefNum> -> <SInt32> -> <ConstStr255Param> -> Ptr <FSSpec> -> IO <OSErr>
#  ccall FSpOpenDF   , Ptr <FSSpec> -> <SInt8> -> Ptr <FSIORefNum> -> IO <OSErr>
#  ccall FSpOpenRF   , Ptr <FSSpec> -> <SInt8> -> Ptr <FSIORefNum> -> IO <OSErr>
#  ccall FSpCreate   , Ptr <FSSpec> -> <OSType> -> <OSType> -> <ScriptCode> -> IO <OSErr>
#  ccall FSpDirCreate, Ptr <FSSpec> -> <ScriptCode> -> Ptr <SInt32> -> IO <OSErr>
#  ccall FSpDelete   , Ptr <FSSpec> -> IO <OSErr>
#  ccall FSpGetFInfo , Ptr <FSSpec> -> Ptr <FInfo> -> IO <OSErr>
#  ccall FSpSetFInfo , Ptr <FSSpec> -> Ptr <FInfo> -> IO <OSErr>
#  ccall FSpSetFLock , Ptr <FSSpec> -> IO <OSErr>
#  ccall FSpRstFLock , Ptr <FSSpec> -> IO <OSErr>
#  ccall FSpRename   , Ptr <FSSpec> -> <ConstStr255Param> -> IO <OSErr>
#  ccall FSpCatMove  , Ptr <FSSpec> -> Ptr <FSSpec> -> IO <OSErr>
#  ccall FSpExchangeFiles , Ptr <FSSpec> -> Ptr <FSSpec> -> IO <OSErr>
#  ccall PBShareSync      , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBShareAsync     , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBUnshareSync    , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBUnshareAsync   , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBGetUGEntrySync , <HParmBlkPtr> -> IO <OSErr>
#  ccall PBGetUGEntryAsync, <HParmBlkPtr> -> IO <OSErr>
#endif
